//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#include "arbre.h"
//---------------------------------------------------------------------------
// pour asFormatAvertissement
#define NBAVERTISSEMENTS   4 // v0.3.3
#define AVRT_ARITEMULTIPLE 0
#define AVRT_ELMTINEXBASE  1
#define AVRT_ARITEINEX     2
#define AVRT_CNTRINUTILE   3 // v0.3.3
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
const IndexBitmapTypeIdentificateur[NBTYPESIDENTIFICATEURS]={0, IDB_REGLEDEFN, IDB_VARIABLEDEFN, IDB_ELEMENTDEFN};
const AnsiString asAvertissement[NBAVERTISSEMENTS]={ "Arit multiple (%d).",
                                                     "lment inexistant dans la base.",
                                                     "Arit inexistante (%d).",
                                                     "Contrainte sans effet."}; // v0.3.3
const AnsiString asLibelleNoeud[NBTYPESNOEUD]={"Base","Rgles","Rgles prdfinies", "Signatures", "Dfinitions","Contraintes","Arguments","lments", "Variables","Recherche", "Question"},
                 asFormatLibelleNoeud = "%s (%d)",
                 asFormatLibelleNoeudSignatures = "Signatures %d-aires (%d)";
//---------------------------------------------------------------------------
// Mthodes globales de arbre.cpp
//---------------------------------------------------------------------------
template <class T> int Nombre(T *t) // ATTENTION dfinie dans base.cpp & arbre.cpp
 {
  if (!t)
   return 0;
  else
   if (t->Svt)
    return 1+Nombre(t->Svt);
   else
    return 1;
 };
//---------------------------------------------------------------------------
template <class SC> int Arite(SC *sc) // ATTENTION dfinie dans base.cpp & arbre.cpp
 { // SC = Signature|Contrainte
  if (!sc)
   return 0;
  else
   return Nombre(sc->Arguments);
 }
//---------------------------------------------------------------------------
// Mthodes des classes de arbre.cpp
//---------------------------------------------------------------------------
TTreeNode *arbre::CreeRacine(const AnsiString asLibelleNoeud, int IndexImage, void *Donnee)
 {
  TTreeNode *TreeNode=NULL;
  if (TreeNode=TreeView->Items->Add(NULL, asLibelleNoeud))
   {
    TreeNode->ImageIndex=IndexImage;
    TreeNode->SelectedIndex=TreeNode->ImageIndex;
    TreeNode->Data=Donnee;
    return TreeNode;
   }
  else
   return NULL;
 };
//---------------------------------------------------------------------------
TTreeNode *arbre::CreeNoeud(TTreeNode *TreeNodeSrc, const AnsiString asLibelleNoeud, int IndexImage, void *Donnee)
 {
  static int n=0; // N de noeud attribu  la cration
  TTreeNode *TreeNode=NULL;
  if (Numerotation) n++;
  if (TreeNode=TreeView->Items->AddChild( TreeNodeSrc,
                                          (Numerotation?
                                           asLibelleNoeud+
                                           Format(" <%d>", ARRAYOFCONST((n))):
                                           asLibelleNoeud)))
   {
    TreeNode->ImageIndex=IndexImage;
    TreeNode->SelectedIndex=TreeNode->ImageIndex;
    TreeNode->Data=Donnee;
    return TreeNode;
   }
  else
   return NULL;
 };
//---------------------------------------------------------------------------
void arbre::CreeArbre(contrainte *Contrainte, TTreeNode *TreeNodeContraintes)
 {
  AnsiString asSignature=Contrainte->asContrainte();
  argument *ArgumentCrt;
  TTreeNode *TreeNodeContrainte=NULL,
            *TreeNodeArguments=NULL;
  if (Contrainte->Regle)
   {
    int n;
    TreeNodeContrainte=CreeNoeud(TreeNodeContraintes, asSignature, IDB_CONTRAINTE, Contrainte);
    if (Contrainte->Regle->Signatures&& // v0.3. Test car peut-tre une rgle prdfinie  arit multiple (Signatures==NULL)
        (!Contrainte->Regle->Signatures->NombreArite(n=Nombre(Contrainte->Arguments))))
     {
      CreeNoeud( TreeNodeContrainte,
                 Format( asAvertissement[AVRT_ARITEINEX],
                         ARRAYOFCONST((n))),
                 IDB_AVERTISSEMENT,
                 Contrainte);
      NbAvertissements++;
     }
    if ((Contrainte->Regle->asIdentificateur==asIdentificateurReglePredefinie[IDENTREGLEPREDEFEXCLUSION])&& // v0.3.3 Test arit(#)<2 (inutile) 
        (Arite(Contrainte)<2))
     {
      CreeNoeud( TreeNodeContrainte,
                 asAvertissement[AVRT_CNTRINUTILE],
                 IDB_AVERTISSEMENT,
                 Contrainte);
      NbAvertissements++;
     }
    CreeNoeud( TreeNodeContrainte,
               Contrainte->Regle->asIdentificateur,
               IDB_REGLECNTR,
               Contrainte); // v0.3 : rgle remplace par la contrainte pour accder  contrainte::PosTxtSrc
   }
  for(ArgumentCrt=Contrainte->Arguments; ArgumentCrt; ArgumentCrt=ArgumentCrt->Svt)
   {
    if (!TreeNodeArguments)
     {
      if (!TreeNodeContrainte) TreeNodeContrainte=CreeNoeud(TreeNodeContraintes, asSignature, IDB_CONTRAINTE, Contrainte);
      TreeNodeArguments=CreeNoeud( TreeNodeContrainte,
                                   Format( asFormatLibelleNoeud,
                                           ARRAYOFCONST(( asLibelleNoeud[ND_ARGUMENTS],
                                                          Nombre(Contrainte->Arguments)))),
                                   IDB_ARGUMENTCNTR,
                                   Contrainte->Arguments);
     }
    CreeNoeud( TreeNodeArguments,
               ArgumentCrt->asIdentificateur,
               IndexBitmapTypeIdentificateur[ArgumentCrt->Type]+1,
               ArgumentCrt);
   }
 }
//---------------------------------------------------------------------------
void arbre::CreeArbre(definition *Definition, TTreeNode *TreeNodeDefinitions)
 {
  objet *VariableCrt, *ElementCrt;
  argument *ArgumentCrt;
  contrainte *ContrainteCrt;
  TTreeNode *TreeNodeDefinition,
            *TreeNodeContraintes;
  TreeNodeDefinition=CreeNoeud( TreeNodeDefinitions,
                                Recherche? AnsiString("Question"):
                                           AnsiString(SeparateurSignatureContraintes)+Definition->asContraintes(),
                                Recherche? IDB_QUESTION:
                                           IDB_DEFINITION,
                                Definition);
  if (Definition->Contraintes)
   {
    TreeNodeContraintes=CreeNoeud( TreeNodeDefinition,
                                   Format( asFormatLibelleNoeud,
                                           ARRAYOFCONST(( asLibelleNoeud[ND_CONTRAINTES],
                                                          Nombre(Definition->Contraintes)))),
                                   IDB_CONTRAINTE,
                                   Definition->Contraintes);
    for(ContrainteCrt=Definition->Contraintes; ContrainteCrt; ContrainteCrt=ContrainteCrt->Svt)
     CreeArbre(ContrainteCrt, TreeNodeContraintes);
   }
 }
//---------------------------------------------------------------------------
void arbre::CreeArbre(signature *Signature, TTreeNode *TreeNodeSignatures)
 {
  AnsiString asSignature=Recherche?asLibelleNoeud[ND_QUESTION]:Signature->asSignature();
  objet *VariableCrt, *ElementCrt;
  argument *ArgumentCrt;
  definition *DefinitionCrt;
  TTreeNode *TreeNodeSignature=NULL,
            *TreeNodeElements=NULL,
            *TreeNodeVariables=NULL,
            *TreeNodeArguments=NULL,
            *TreeNodeDefinitions=NULL;

  TreeNodeSignature=CreeNoeud(TreeNodeSignatures, asSignature, IDB_SIGNATURE, Signature);
  for(ElementCrt=Signature->Objets; ElementCrt; ElementCrt=ElementCrt->Svt)
   if (ElementCrt->Type==tiElement)
    {
     if (!TreeNodeElements)
      TreeNodeElements=CreeNoeud( TreeNodeSignature,
                                  Format( asFormatLibelleNoeud,
                                          ARRAYOFCONST(( asLibelleNoeud[ND_ELEMENTS],
                                                         Signature->Objets->Nombre(tiElement)))),
                                  IDB_ELEMENTDECL,
                                  Signature->Objets);
     CreeNoeud(TreeNodeElements, ElementCrt->asIdentificateur, IDB_ELEMENTDECL, ElementCrt);
    }
  for(VariableCrt=Signature->Objets; VariableCrt; VariableCrt=VariableCrt->Svt)
   if (VariableCrt->Type==tiVariable)
    {
     if (!TreeNodeVariables)
      TreeNodeVariables=CreeNoeud( TreeNodeSignature,
                                  Format( asFormatLibelleNoeud,
                                          ARRAYOFCONST(( asLibelleNoeud[ND_VARIABLES],
                                                         Signature->Objets->Nombre(tiVariable)))),
                                   IDB_VARIABLEDECL,
                                   Signature->Objets);
     CreeNoeud(TreeNodeVariables, VariableCrt->asIdentificateur, IDB_VARIABLEDECL, VariableCrt);
    }
  for(ArgumentCrt=Signature->Arguments; ArgumentCrt; ArgumentCrt=ArgumentCrt->Svt)
   {
    if (!TreeNodeArguments)
     TreeNodeArguments=CreeNoeud( TreeNodeSignature,
                                  Format( asFormatLibelleNoeud,
                                          ARRAYOFCONST(( asLibelleNoeud[ND_ARGUMENTS],
                                                         Nombre(Signature->Arguments)))),
                                  IDB_ARGUMENTDEFN,
                                  Signature->Arguments);
    CreeNoeud( TreeNodeArguments,
               ArgumentCrt->asIdentificateur,
               IndexBitmapTypeIdentificateur[ArgumentCrt->Type],
               ArgumentCrt);
   }
  for(DefinitionCrt=Signature->Definitions; DefinitionCrt; DefinitionCrt=DefinitionCrt->Svt)
   {
    if (!TreeNodeDefinitions)
     TreeNodeDefinitions=CreeNoeud( TreeNodeSignature,
                                    Format( asFormatLibelleNoeud,
                                            ARRAYOFCONST(( asLibelleNoeud[ND_DEFINITIONS],
                                                           Nombre(Signature->Definitions)))),
                                    IDB_DEFINITION,
                                    Signature->Definitions);
    CreeArbre(DefinitionCrt, TreeNodeDefinitions);
   }
 }
//---------------------------------------------------------------------------
void arbre::CreeArbre(regle *Regle, TTreeNode *TreeNodeRegles)
 {
  int NbSignatures=Nombre(Regle->Signatures),
      NbSignaturesFaites,
      NbSignaturesAriteCrt,
      Arite,
      NbArites;
  signature *SignatureCrt;
  TTreeNode *TreeNodeRegle,
            *TreeNodeSignatures=NULL;
  TreeNodeRegle=CreeNoeud(TreeNodeRegles, Regle->asIdentificateur, IDB_REGLEDEFN, Regle);
  if (!Regle->Signatures) return; // Improbable mais bon...
  if ((NbArites=Regle->NombreAritesDifferentes())>1)
   {
    CreeNoeud( TreeNodeRegle,
               Format( asAvertissement[AVRT_ARITEMULTIPLE],
                       ARRAYOFCONST((NbArites))),
               IDB_AVERTISSEMENT,
               Regle);
    NbAvertissements++;
   }
  for( Arite=NbSignaturesFaites=0;
       NbSignaturesFaites!=NbSignatures;
       Arite++,NbSignaturesFaites+=NbSignaturesAriteCrt)
   {
    if (NbSignaturesAriteCrt=Regle->Signatures->NombreArite(Arite))
     TreeNodeSignatures=CreeNoeud( TreeNodeRegle,
                                   Format( asFormatLibelleNoeudSignatures,
                                           ARRAYOFCONST(( Arite,
                                                          NbSignaturesAriteCrt))),
                                   IDB_SIGNATURE,
                                   Regle->Signatures);
    for( SignatureCrt=Regle->Signatures->SignatureArite(Arite);
         SignatureCrt;
         SignatureCrt=SignatureCrt->SignatureSvtArite(Arite))
     CreeArbre(SignatureCrt, TreeNodeSignatures);
   }
 }
//---------------------------------------------------------------------------
void arbre::CreeArbre(TStatusBar *StatusBar)
 {
  TTreeNode *TreeNodeRacine=NULL,
            *TreeNodeElements=NULL,
            *TreeNodeReglesPredefinies=NULL,
            *TreeNodeRegles=NULL,
            *TreeNodeElementCrt,
            *TreeNodeReponse;
  regle *RegleCrt;
  objet *ElementCrt;
  TreeView->Items->Clear();
  if (!Recherche) // Arbre de la base
   {
    TreeNodeRacine=CreeRacine(asLibelleNoeud[ND_BASE], IDB_BASE, Base);
    TreeNodeReglesPredefinies=CreeNoeud( TreeNodeRacine,
                                         Format( asFormatLibelleNoeud,
                                                 ARRAYOFCONST(( asLibelleNoeud[ND_REGLESPRDF],
                                                                NBIDENTIFICATEURSREGLEPREDEFINIE))),  // A REACTIVER quand l'oprateur sera fini
                                         IDB_REGLEPRDF,
                                         NULL);
    for(int i=1; i<=NBIDENTIFICATEURSREGLEPREDEFINIE; i++)
     CreeNoeud(TreeNodeReglesPredefinies, asIdentificateurReglePredefinie[i], IDB_REGLEPRDF, NULL);
    if (Base->Objets)
     TreeNodeElements=CreeNoeud( TreeNodeRacine,
                                 Format( asFormatLibelleNoeud,
                                         ARRAYOFCONST(( asLibelleNoeud[ND_ELEMENTS],
                                                        Base->Objets->Nombre(tiElement)))),
                                 IDB_ELEMENTDECL,
                                 Base->Objets);
    for(ElementCrt=Base->Objets; ElementCrt; ElementCrt=ElementCrt->Svt)
     if (ElementCrt->Type==tiElement)
      CreeNoeud(TreeNodeElements, ElementCrt->asIdentificateur, IDB_ELEMENTDECL, ElementCrt);
    if (Base->Regles)
     TreeNodeRegles=CreeNoeud( TreeNodeRacine,
                               Format( asFormatLibelleNoeud,
                                       ARRAYOFCONST(( asLibelleNoeud[ND_REGLES],
                                                      Nombre(Base->Regles)))),
                               IDB_REGLEDEFN,
                               Base->Regles);
    for(RegleCrt=Base->Regles; RegleCrt; RegleCrt=RegleCrt->Svt)
     CreeArbre(RegleCrt, TreeNodeRegles);
   }
  else // Arbre de la recherche
   {
    TreeNodeRacine=CreeRacine(asLibelleNoeud[ND_RECHERCHE], IDB_RECHERCHE, Recherche);
    if (Recherche->Objets)
     {
      int n;
      if (n=Recherche->Objets->Nombre(tiElement))
       {
        TreeNodeElements=CreeNoeud( TreeNodeRacine,
                                    Format( asFormatLibelleNoeud,
                                            ARRAYOFCONST(( asLibelleNoeud[ND_ELEMENTS],
                                                           n))),
                                    IDB_ELEMENTDECL,
                                    Recherche->Objets);
        for(ElementCrt=Recherche->Objets; ElementCrt; ElementCrt=ElementCrt->Svt)
         if (ElementCrt->Type==tiElement)
          {
           TreeNodeElementCrt=CreeNoeud(TreeNodeElements, ElementCrt->asIdentificateur, IDB_ELEMENTDECL, ElementCrt);
           if ((!Base->Objets)||(!Base->Objets->Objet(ElementCrt->asIdentificateur, tiElement)))
            {
             CreeNoeud( TreeNodeElementCrt,
                        asAvertissement[AVRT_ELMTINEXBASE],
                        IDB_AVERTISSEMENT,
                        ElementCrt);
             NbAvertissements++;
            }
          }
       }
      if (n=Recherche->Objets->Nombre(tiVariable))
       {
        TreeNodeElements=CreeNoeud( TreeNodeRacine,
                                    Format( asFormatLibelleNoeud,
                                            ARRAYOFCONST(( asLibelleNoeud[ND_VARIABLES],
                                                           n))),
                                    IDB_VARIABLEDECL,
                                    Recherche->Objets);
        for(ElementCrt=Recherche->Objets; ElementCrt; ElementCrt=ElementCrt->Svt)
         if (ElementCrt->Type==tiVariable)
          CreeNoeud(TreeNodeElements, ElementCrt->asIdentificateur, IDB_VARIABLEDECL, ElementCrt);
       }
     }
    if (Recherche->Question) CreeArbre(Recherche->Question, TreeNodeRacine);
    TreeNodeReponse=CreeNoeud( TreeNodeRacine,
                               "Rponse",
                               IDB_REPONSE,
                               NULL);
    Recherche->TreeNodeTrace=CreeNoeud( TreeNodeReponse,
                                        "Trace",
                                        IDB_TRACE,
                                        NULL);
    Recherche->TreeNodeSolutions=CreeNoeud( TreeNodeReponse,
                                            Recherche->asNbSolutions(),
                                            IDB_SOLUTION,
                                            NULL);
   }
  if (NbAvertissements)
   {
    StatusBar->SimpleText= Format( "Analyse %s[%s] : %d avertissement(s).",
                                   ARRAYOFCONST(( asCibleAnalyse[Recherche?CA_QUESTION:CA_BASE],
                                                  asTypeMsgAnalyse[TMA_SEM],
                                                  NbAvertissements)));
    MontreAvertissements();
   }
 }
//---------------------------------------------------------------------------
void arbre::MontreAvertissements(TTreeNode *TreeNode)
 {
  if (TreeNode->ImageIndex==IDB_AVERTISSEMENT)
   for(TTreeNode *ParentCrt=TreeNode->Parent; ParentCrt; ParentCrt=ParentCrt->Parent)
    if (!ParentCrt->Expanded)
     ParentCrt->Expand(false);
  for(int i=0; i<TreeNode->Count; i++)
   MontreAvertissements(TreeNode->Item[i]);
 }
//---------------------------------------------------------------------------
void arbre::MontreAvertissements()
 {
  for(int i=0; i<TreeView->Items->Count; i++)
   MontreAvertissements(TreeView->Items->Item[i]);
 }
//---------------------------------------------------------------------------

