//---------------------------------------------------------------------------
#pragma hdrstop
//---------------------------------------------------------------------------
#ifdef PRFD_WINDOWSLINUX
#include <Forms.hpp>
#include <QForms.hpp>
#endif
//---------------------------------------------------------------------------
#ifdef PRFD_WINDOWS
#include <Forms.hpp>
#endif
//---------------------------------------------------------------------------
#ifdef PRFD_LINUX
#include <QForms.hpp>
#endif
//---------------------------------------------------------------------------
#include "base.h"
#include "arbre.h"
#include "winlinux.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Pour asEchecReussite
#define ECHEC    0
#define REUSSITE 1
// Pour [inconnue_]condition::AjouteInconnue(...)
#define SI_INEXISTANTE    true
#define MEME_SI_EXISTANTE false
//---------------------------------------------------------------------------
// Pour AjouteTraceArbre(...)
#define NOEUD_COURANT false
#define NOUVEAU_NOEUD true  
//---------------------------------------------------------------------------
// Pour Unifie(...)
#define DERNIERE_CONTRAINTE_PARENT true
//---------------------------------------------------------------------------
const AnsiString asVide = "",
                 asIdentificateurVariableTemporaire = "$",
                 asIdentificateurReglePredefinie[NBIDENTIFICATEURSREGLEPREDEFINIE+1]={"","#"}, // A COMPLETER (lorsque les ensembles ordonns seront implments) : {"#","<",">","<=",">="};
                 asTypeCondition[NBIDENTIFICATEURSREGLEPREDEFINIE+1]={"indfini","Exclusion"}; // A COMPLETER (lorsque les ensembles ordonns seront implments) : {"#","<",">","<=",">="};

// Seule variable globale (et de taille). Evite les rfrences rptitives dans les arborescences
base *Base=NULL;
recherche *Recherche=NULL;
objet VariableTemporaire(asIdentificateurVariableTemporaire, tiVariable); // Variable temporaire
regle ReglesPredefinies((type_condition)(tcIndefini+1)); // Rgles prdfinies
/*
CONVENTION
[...]  = 0 ou 1 fois
[...]* = 0, 1, ou plusieurs fois
(...)  = 1 fois
(...)* = 1 ou plusieurs fois
X..Y   = 1 caractre dans l'intervalle de X  Y inclus (suivant l'ordre ASCII)

GRAMMAIRE version 0.3

base ::= rgle [";" rgle]* "."
question ::= contraintes "?"
rgle ::=  identificateur_rgle_non_prdfinie "(" [arguments] ")" [":" contraintes]
contraintes ::= contrainte ["," contrainte]*
contrainte ::= identificateur_rgle "(" [arguments] ")"
arguments ::= argument ["," argument]*
argument ::= identificateur_lment | identificateur_variable
identificateur_rgle ::= identificateur_rgle_prdfinie | identificateur_rgle_non_prdfinie
identificateur_rgle_prdfinie ::= "#"
identificateur_rgle_non_prdfinie ::= ("a".."z") + ("a".."z" | "_" | "0".."9")*
identificateur_lment ::= ("A".."Z") + ("a".."z" | "A".."Z" | "_" | "0".."9")*
identificateur_variable ::= ("A".."Z" | "_" | "0".."9")*
dbut_commentaire ::= "%"
*/
//---------------------------------------------------------------------------
// Constantes globales exportables
//---------------------------------------------------------------------------
const AnsiString asListeArgumentsVide = "()",
                 asDebutSolution = "{ ",
                 asFinSolution = " }",
                 asSolutionVide = "{}",
                 asValeurIndefinie = "?",
                 asEchecReussite[2]={"CHEC","RUSSITE"},
                 asMarqueLargeur[3]={"","*","+"},
                 asFrmNbSolutions="Solutions (%d)",
                 asFrmEchecReussite="%s de%s \"%s\"",
                 asAucuneContrainte="Aucune contrainte",
                 asDeLaContrainte=" la contrainte ",
                 asDeLaDefinition=" la dfinition ",
                 asSuffixeCodeSituation = "0";
const char Souligne = '_',
           SeparateurSignatureContraintes = ':',
           SeparateurArguments = ',',
           SeparateurContraintes = ',',
           SeparateurRegles = ';',
           DebutListeArguments = '(',
           FinListeArguments = ')',
           FinListeRegles = '.',
           FinQuestion = '?',
           DebutCommentaire = '%'; // v0.2
//---------------------------------------------------------------------------
// Mthodes globales  base.cpp
//---------------------------------------------------------------------------
template <class T> int Nombre(T *t) // ATTENTION dfinie dans base.cpp & arbre.cpp
 {
  if (!t)
   return 0;
  else
   if (t->Svt)
    return 1+Nombre(t->Svt);
   else
    return 1;
 };
//---------------------------------------------------------------------------
template <class SC> int Arite(SC *sc) // ATTENTION dfinie dans base.cpp & arbre.cpp
 { // SC = Signature|Contrainte
  if (!sc)
   return 0;
  else
   return Nombre(sc->Arguments);
 }
//---------------------------------------------------------------------------
template <class S,class D> void ReleveObjetsSrcDst(S *s, D *d)
 {
  for(D *dCrt=d; dCrt; dCrt=dCrt->Svt)
   dCrt->ReleveObjets(s);
 }
//---------------------------------------------------------------------------
template <class S> objet *Objet(S *s, const AnsiString asIdentificateur, type_identificateur Type)
 {
  if (s->Objets)
   return s->Objets->Objet(asIdentificateur, Type);
  else
   return NULL;
 }
//---------------------------------------------------------------------------
template <class S> void CreeAjouteEtReferenceObjetSiNecessaire(S *s, objet **ObjetRef, const AnsiString asIdentificateur, type_identificateur Type)
 {
  objet *ObjetAReferencer=NULL;
  if (!(ObjetAReferencer=Objet(s, asIdentificateur, Type))) // S'il n'existe pas dans s->Objets...
   if (s->Objets) // On cre l'objet et on l'ajoute dans s->Objets
    ObjetAReferencer=s->Objets->AjouteObjet(new objet(s, asIdentificateur, Type));
   else
    ObjetAReferencer=s->Objets=new objet(s, asIdentificateur, Type);
   if (!(*ObjetRef)) (*ObjetRef)=ObjetAReferencer; // Si l'objet n'a pas t rfrenc (dans argument) on le fait
 }
//---------------------------------------------------------------------------
template <class SD> void indicateur_recherche<SD>::SupprimeSuivant() // Utilis par une mthode de la classe template indicateur_recherche<SD>.
 {
  indicateur_recherche<SD> *Tmp=Svt;
  Svt=Svt->Svt;
  Tmp->Svt=NULL;
  delete Tmp;
 }
//---------------------------------------------------------------------------
// Mthodes des classes de base.cpp
//---------------------------------------------------------------------------
AnsiString argument::asArguments()
 {
  return Svt?
         (asIdentificateur+
          AnsiString(SeparateurArguments)+
          Svt->asArguments()):
         asIdentificateur;
 }
//---------------------------------------------------------------------------
template <class S> void contrainte::ReleveObjets(S *s)
 {
  if (Arguments) ReleveObjetsSrcDst(s, Arguments);
 }
//---------------------------------------------------------------------------
template <class SD> indicateur_recherche<SD> *SupprimePremierIndicateurRecherche(indicateur_recherche<SD> *Prm)
 {
  indicateur_recherche<SD> *Tmp=Prm->Svt;
  Prm->Svt=NULL;
  delete Prm;
  return Tmp;
 }
//---------------------------------------------------------------------------
AnsiString contrainte::asContrainte()
 {
  if (Arguments)
   return Regle->asIdentificateur+
          AnsiString(DebutListeArguments)+
          Arguments->asArguments()+
          AnsiString(FinListeArguments);
  else
   return Regle->asIdentificateur+
          asListeArgumentsVide;
 }
//---------------------------------------------------------------------------
void contrainte::InitialiseIndicateursRecherche()
 {
  if (Base->asCodeRacine==asVide)
   {
    if (SignatureCrt) { delete SignatureCrt; SignatureCrt=NULL; };
    if (DefinitionCrt) { delete DefinitionCrt; DefinitionCrt=NULL; };
   }
  else
   {
    if (SignatureCrt)
     {
      if (SignatureCrt->CodeAReinitialiser())
       SignatureCrt=SupprimePremierIndicateurRecherche(SignatureCrt);
      if (SignatureCrt) SignatureCrt->InitialiseIndicateursRecherche();
     }
    if (DefinitionCrt)
     {
      if (DefinitionCrt->CodeAReinitialiser())
       DefinitionCrt=SupprimePremierIndicateurRecherche(DefinitionCrt);
      if (DefinitionCrt) DefinitionCrt->InitialiseIndicateursRecherche();
     }
   }
  if (Svt) Svt->InitialiseIndicateursRecherche();
 }
//---------------------------------------------------------------------------
void contrainte::DefinitSignatureCrt(const AnsiString asCode, signature *Signature)
 {
  if ((!SignatureCrt)||(Signature!=SignatureCrt->CrtCode(asCode, Signature))) // La signature courante a chang : on rinitialise les indicateurs
   Base->InitialiseIndicateursRecherche(asCode);
  if (!SignatureCrt)
   SignatureCrt=new indicateur_recherche<signature>(asCode, Signature, NULL);
  else
   if (asCode<SignatureCrt->asCode)
    SignatureCrt=new indicateur_recherche<signature>(asCode, Signature, SignatureCrt);
   else
    SignatureCrt->Definit(asCode, Signature);
 }
//---------------------------------------------------------------------------
void contrainte::DefinitDefinitionCrt(const AnsiString asCode, definition *Definition)
 {
  if ((!DefinitionCrt)||(Definition!=DefinitionCrt->CrtCode(asCode, Definition))) // La dfinition courante a chang : on rinitialise les indicateurs
   Base->InitialiseIndicateursRecherche(asCode);
  if (!DefinitionCrt)
   DefinitionCrt=new indicateur_recherche<definition>(asCode, Definition, NULL);
  else
   if (asCode<DefinitionCrt->asCode)
    DefinitionCrt=new indicateur_recherche<definition>(asCode, Definition, DefinitionCrt);
   else
    DefinitionCrt->Definit(asCode, Definition);
 }
//---------------------------------------------------------------------------
template <class S> void definition::ReleveObjets(S *s)
 {
  if (Contraintes) ReleveObjetsSrcDst(s, Contraintes);
 }
//---------------------------------------------------------------------------
signature *signature::SignatureArite(int NvArite)
 {
  if (Arite(this)==NvArite)
   return this;
  else
   return SignatureSvtArite(NvArite);
 }
//---------------------------------------------------------------------------
int signature::NombreArite(int NvArite)
 {
  return (Arite(this)==NvArite)+(Svt?Svt->NombreArite(NvArite):0);
 }
//---------------------------------------------------------------------------
signature *signature::SignatureSvtArite(int NvArite)
 {
  if (Svt)
   if (Arite(Svt)==NvArite)
    return Svt;
   else
    return Svt->SignatureSvtArite(NvArite);
  else
   return NULL;
 }
//---------------------------------------------------------------------------
template <class S> void signature::ReleveObjets(S *s)
 {
  if (Arguments) ReleveObjetsSrcDst(s, Arguments);
  if (Definitions) ReleveObjetsSrcDst(s, Definitions);
 }
//---------------------------------------------------------------------------
AnsiString signature::asSignature()
 {
  if (Arguments)
   return AnsiString(DebutListeArguments)+
          Arguments->asArguments()+
          AnsiString(FinListeArguments);
  else
   return asListeArgumentsVide;
 }
//---------------------------------------------------------------------------
regle::regle(type_condition TypeReglePredefinie) // constructeur de rgle prdfinie. NumeroIdentificateurPredefini commence  1
 {
  Initialise();
  this->TypeReglePredefinie=TypeReglePredefinie;
  asIdentificateur=asIdentificateurReglePredefinie[TypeReglePredefinie];
  if (TypeReglePredefinie<=NBIDENTIFICATEURSREGLEPREDEFINIE)
   Svt=new regle((type_condition)(TypeReglePredefinie+1));
 }
//---------------------------------------------------------------------------
int regle::NombreAritesDifferentes()
 {
  int NbArites,
      NbSignatures=Nombre(Signatures),
      NbSignaturesFaites,
      NbSignaturesAriteCrt,
      Arite;
  signature *SignatureCrt;
  if (!NbSignatures) return 0; // Cas d'une rgle prdfinie  arit multiple. v0.3
  for( NbArites=Arite=NbSignaturesFaites=0;
       NbSignaturesFaites!=NbSignatures;
       Arite++,NbSignaturesFaites+=NbSignaturesAriteCrt)
   if (NbSignaturesAriteCrt=Signatures->NombreArite(Arite))
    NbArites++;
  return NbArites;
 }
//---------------------------------------------------------------------------
template <class S> void regle::ReleveObjets(S *s)
 {
  if (Signatures) ReleveObjetsSrcDst(s, Signatures);
 }
//---------------------------------------------------------------------------
void regle::AjouteDefinition(definition *Definition, argument *Arguments)  // Ajoute "Definition"  la rgle dont la signature a pour arguments "Arguments"
 {
  signature *Signature=NULL;
  if (Signatures)
   if (Signature=Signatures->Trouve(Arguments))
    if (Signature->Definitions)
     Signature->Definitions->AjouteDefinition(Definition);
    else
     Signature->Definitions=Definition;
   else
    Signatures->AjouteSignature(Signature=new signature(Definition, Arguments));
  else
   Signatures=(Signature=new signature(Definition, Arguments));
 }
//---------------------------------------------------------------------------
void base::ReleveObjets()
 {
  if (Regles) ReleveObjetsSrcDst(this, Regles);
 }
//---------------------------------------------------------------------------
void recherche::ReleveObjets()
 {
  if (Question) ReleveObjetsSrcDst(this, Question);
 }
//------------------------------------------------------------------------------
// Mthodes utilises pour la recherche de solutions (toutes classes confondues)
//------------------------------------------------------------------------------
void inconnue_condition::Enrichit(inconnue_condition *Inconnues) // Ajoute les nouvelles inconnues (Inconnues)
 {
  inconnue_condition *InconnueSvt=Inconnues->Svt;
  if (!Svt)
   { // On cherche la prochaine variable renomme (asIdentificateurPrc dfini)
    for( ;
         InconnueSvt&&(InconnueSvt->Inconnue->asIdentificateurPrc==asVide);
         InconnueSvt=InconnueSvt->Svt);
    if (InconnueSvt)
     Svt=new inconnue_condition( Condition,
                                 Condition->Situation->Inconnues->Inconnue(InconnueSvt->Inconnue->asIdentificateurPrc));
   }
  if (InconnueSvt) Svt->Enrichit(InconnueSvt);
 }
//------------------------------------------------------------------------------
AnsiString inconnue_condition::asInconnues()
 {
  return Inconnue->asInconnue()+
         (Svt?
          AnsiString(SeparateurArguments)+Svt->asInconnues():
          asVide);
 };
//------------------------------------------------------------------------------
AnsiString inconnue_condition::asResultatInconnues()
 {
  return Inconnue->asResultatInconnue()+
         (Svt?
          AnsiString(SeparateurArguments)+Svt->asResultatInconnues():
          asVide);
 };
//------------------------------------------------------------------------------
condition::condition(situation *Situation, condition *ConditionPrc)
 {
  Initialise();
  this->Situation=Situation;
  this->Type=ConditionPrc->Type;
  this->Possible=ConditionPrc->Possible;
  for( inconnue_condition *InconnueCrt=ConditionPrc->Inconnues;
       InconnueCrt;
       InconnueCrt=InconnueCrt->Svt) // On copie les nouvelles variables en passant par leur ancien identificateur
   AjouteInconnue( Situation->Inconnues->InconnueIdentificateurPrc(InconnueCrt->Inconnue->Variable->asIdentificateur),
                    MEME_SI_EXISTANTE);
  if (ConditionPrc->Svt) Svt=new condition(Situation, ConditionPrc->Svt); // copie par rcurrence
 }
//------------------------------------------------------------------------------
void condition::Enrichit(condition *Condition) // Ajoute chaque condition cre dans Condition qui utilise des variables de this
 {
  inconnue_condition *InconnueSvt=Condition->Inconnues;
  if (!Inconnues)
   { // On cherche la prochaine variable renomme (asIdentificateurPrc dfini)
    for( ;
         InconnueSvt&&(InconnueSvt->Inconnue->asIdentificateurPrc==asVide);
         InconnueSvt=InconnueSvt->Svt);
    if (InconnueSvt)
     Inconnues=new inconnue_condition( this,
                                       Situation->Inconnues->Inconnue(InconnueSvt->Inconnue->asIdentificateurPrc));
   }
  Inconnues->Enrichit(InconnueSvt);
  if (Condition->Svt)
   {
    if (!Svt) Svt=new condition(this->Situation, Condition->Svt->Type);
    Svt->Enrichit(Condition->Svt);
   }
 }
//------------------------------------------------------------------------------
bool condition::Possibles() // Renvoie faux s'il y a au moins une contradiction dans la condition (stocke alors dans Possible)
 {
  if (!Possible) return false; // Pas besoin d'valuer : c'est dj impossible !
  switch(Type)
   {
    tcExclusion: // Si 2 inconnues sont affectes du mme objet alors il y a contradiction (X diffrent de X)
                 for(inconnue_condition *InconnueCrt1=Inconnues; Possible&&InconnueCrt1; InconnueCrt1=InconnueCrt1->Svt)
                  if (InconnueCrt1)
                   for(inconnue_condition *InconnueCrt2=InconnueCrt1->Svt; Possible&&InconnueCrt2; InconnueCrt2=InconnueCrt2->Svt)
                   if ((InconnueCrt1->Inconnue==InconnueCrt2->Inconnue)|| // SOIT les inconnues sont identiques (rfrences pas identificateurs)
                       (InconnueCrt1->Inconnue->Objet&&InconnueCrt2->Inconnue->Objet&&
                        (InconnueCrt1->Inconnue->Objet->asIdentificateur==InconnueCrt2->Inconnue->Objet->asIdentificateur))) // SOIT les objets affects sont identiques (identificateurs)
                     Possible=false; // ALORS, il y a contradiction
    default: break;
   }
  if (Recherche->Trace)
   {
    AnsiString asNvConditions=asCondition();
    Situation->AjouteTraceArbre(Possible?IDB_REUSSITE:IDB_ECHEC, asNvConditions, NOEUD_COURANT);
   }
  if (Svt)
   return Possible&&Svt->Possibles(); // ET toutes les autres doivent tre possibles...
  else
   return Possible;
 };
//------------------------------------------------------------------------------
bool condition::Utile()
 {
  bool InconnueAffectee=true;
  for( inconnue_condition *InconnueCrt=Inconnues;
       InconnueAffectee&&InconnueCrt;
       InconnueCrt=InconnueCrt->Svt)
   InconnueAffectee= InconnueCrt->Inconnue&&
                     InconnueCrt->Inconnue->Objet;
  return !InconnueAffectee;
 }
//------------------------------------------------------------------------------
bool condition::Utiles()
 {
  return Utile()&&((!Svt)||(Svt->Utiles()));
 }
//------------------------------------------------------------------------------
AnsiString condition::asCondition()
 {
  return asIdentificateurReglePredefinie[Type]+
         AnsiString(DebutListeArguments)+
         (Inconnues?Inconnues->asInconnues():asVide)+
         AnsiString(FinListeArguments);
 };
//------------------------------------------------------------------------------
AnsiString condition::asResultatCondition()
 {
  return asIdentificateurReglePredefinie[Type]+
         AnsiString(DebutListeArguments)+
         (Inconnues?Inconnues->asResultatInconnues():asVide)+
         AnsiString(FinListeArguments);
 };
//------------------------------------------------------------------------------
inconnue::inconnue(situation *AncSituation, const argument *AncArguments, situation *NvSituation, argument *NvArguments) // Constructeur de copie
 { // Pr-requis : SituationPrc (Inconnues ET But) & [Nv&Anc]Arguments dfinis.
  Initialise(); this->Situation=NvSituation;
  if (NvArguments->Type!=tiVariable)
   { // Le nouvel argument n'est pas une variable : on en cre une temporaire pour faire correspondre les arguments au retour de l'unification
    Variable=&VariableTemporaire;
    if (!Objet)
     {
      Objet=NvArguments->Objet;
      LargeurObjet=Situation->Largeur;
     }
   }
  else
   Variable=NvArguments->Objet;
  if (AncArguments->Type!=tiVariable) // Si l'argument tait un objet autre qu'une variable...
   {
    if (!Objet)
     {
      Objet=AncArguments->Objet; // on l'affecte  la nouvelle variable
      LargeurObjet=Situation->Largeur;
     }
   }
  else
   {
    asIdentificateurPrc=AncArguments->asIdentificateur; // On sauvegarde l'identificateur d'origine
    if (inconnue *Inconnue=AncSituation->Inconnues->Inconnue(AncArguments->asIdentificateur))
     if (!Objet)
      {
       Objet=Inconnue->Objet; // Si la variable correspondante dans l'ancienne situation tait affecte, on affecte  nouveau l'objet  la variable correspondante
       LargeurObjet=Situation->Largeur;
      }
   }
  if (AncArguments->Svt&&NvArguments->Svt)
   Svt=new inconnue(AncSituation, AncArguments->Svt, NvSituation, NvArguments->Svt);
 }
//---------------------------------------------------------------------------
void inconnue::Enrichit(inconnue *Inconnue) // Dfinit les objets si les identificateurs correspondent
 {
  if ((!Inconnue)) return; // Tolre l'utilisation de inconnue::Inconnue(...)
  if ((Inconnue->asIdentificateurPrc==Variable->asIdentificateur)||
      (Inconnue->Variable->asIdentificateur==Variable->asIdentificateur))
   {
    if ((!Objet)&&Inconnue->Objet)
     {
      Objet=Inconnue->Objet;
      LargeurObjet=Situation->Largeur;
     }
    else
     if (Svt)
      Svt->Enrichit(Inconnue);
   }
  else
   if (Svt)
    Svt->Enrichit(Inconnue);
 }
//---------------------------------------------------------------------------
void inconnue::ReinitialiseVariables()
 {
  if (Objet&&LargeurObjet>=Situation->Largeur)
   Objet=NULL;
  if (Svt) Svt->ReinitialiseVariables();
 }
//---------------------------------------------------------------------------
AnsiString inconnue::asSolution()
 {
  return Variable->asIdentificateur+
         "="+
         ( Objet?
           Objet->asValeur():
           asValeurIndefinie)+
         ( Svt?
           (AnsiString(" ; ")+Svt->asSolution()):
           ( Situation->Conditions&&Situation->Conditions->Utiles()?
             (AnsiString(" ; ")+Situation->asResultatConditionsUtiles()):
             asVide)+
           asFinSolution);
 }
//---------------------------------------------------------------------------
void situation::Initialise()
 {
  SituationPrc=NULL;
  ArgumentsPrc=NULL;
  ArgumentsSignature=NULL;
  Largeur=Profondeur=0;
  asCode=asSuffixeCodeSituation;
  Inconnues=NULL;
  ArgumentsBut=NULL;
  Conditions=NULL;
  TreeNodeCrt=NULL;
 };
//---------------------------------------------------------------------------
situation::situation(situation *SituationPrc, argument *ArgumentsSignature, argument *ArgumentsPrc) // Constructeur de fils
 {  // Cre une situation en faisant correspondre les variables ArgumentsPrc->ArgumentsNvBut.
  Initialise();
  if (SituationPrc)
   {
    this->SituationPrc=SituationPrc;
    Profondeur=SituationPrc->Profondeur+1;
    asCode=SituationPrc->asCode+asSuffixeCodeSituation;
    TreeNodeCrt=SituationPrc->TreeNodeCrt;
   }
  if (ArgumentsSignature->Signature) // a vient d'une signature (cas normal) : il faut faire la correspondance des variables
   {
    this->ArgumentsPrc=ArgumentsPrc;
    Inconnues=new inconnue(SituationPrc, ArgumentsPrc, this, ArgumentsSignature); // On transfert d'abord les inconnues...
    if (SituationPrc->Conditions) // ...puis leurs conditions (en utilisant leurs identificateurs prcdents)
     Conditions=new condition(this, SituationPrc->Conditions);
    this->ArgumentsSignature=ArgumentsSignature;
   }
  if (ArgumentsSignature->Contrainte) // CE N'EST PAS UNE SIGNATURE, MAIS DES CONTRAINTES : cas initial de la question au dpart = ensemble de contraintes) : on complte simplement les variables
   CompleteInconnuesEtDefinitBut(ArgumentsSignature);
 }
//---------------------------------------------------------------------------
void situation::Reinitialise(argument *ArgumentsBut)
 {
  if (Inconnues) { delete Inconnues; Inconnues=NULL; }
  this->ArgumentsBut=ArgumentsBut;
  if (ArgumentsSignature) // a vient d'une signature (cas normal) : il faut faire la correspondance des variables
   {
    Inconnues=new inconnue(SituationPrc, ArgumentsPrc, this, ArgumentsSignature); // On transfert d'abord les inconnues...
    if (SituationPrc->Conditions) // ...puis leurs conditions (en utilisant leurs identificateurs prcdents)
     Conditions=new condition(this, SituationPrc->Conditions);
   }
  // Dans tous les cas...
  CompleteInconnuesEtDefinitBut(ArgumentsBut);
 }
//---------------------------------------------------------------------------
bool situation::UnifiableAvecArgumentsBut(argument *Arguments) // Pr-requis : Inconnues doit connatre les variables de ArgumentsBut
 {
  bool Ok;
  argument *ArgumentBut, *ArgumentCrt;
  objet *ObjetBut, *ObjetCrt;
  for( Ok=true,ArgumentBut=ArgumentsBut,ArgumentCrt=Arguments;
       Ok&&ArgumentBut&&ArgumentCrt;
       ArgumentBut=ArgumentBut->Svt,ArgumentCrt=ArgumentCrt->Svt)
   {
    ObjetBut=ArgumentBut->Objet;
    if (Inconnues) // Si ObjetBut est une variable on le remplace par l'objet associ qui lui est affect
     Inconnues->ChangeObjetSiVariableAffectee(&ObjetBut);
    ObjetCrt=ArgumentCrt->Objet;
    Ok=(ObjetBut->Type==tiVariable)||
       (ObjetCrt->Type==tiVariable)||
       (ObjetBut->EstIdentiqueA(ObjetCrt));
   }
  return Ok&&(!ArgumentBut)&&(!ArgumentCrt);
 }
//----------------------------------------------------------------------------------------------------------------------------------
void situation::CompleteInconnuesEtDefinitBut(argument *Arguments) // Ajoute les inconnues d'Arguments
 {
  for(argument *ArgumentCrt=Arguments; ArgumentCrt; ArgumentCrt=ArgumentCrt->Svt)
   if (ArgumentCrt->Objet&&(ArgumentCrt->Objet->Type==tiVariable))
    AjouteInconnueSiInexistante(ArgumentCrt->Objet);
  if (ArgumentsBut!=Arguments) ArgumentsBut=Arguments; // Le but devient la contrainte elle-mme (si construction de situation mais PAS Rinitialisation)
 }
//---------------------------------------------------------------------------
void situation::EnrichitInconnuesEtConditions(situation *NvSituation) // Enrichit this de NvSituation (Inconnues & nouvelles conditions de NvSituation->Conditions)
 {
  // D'abord les incoonnues...
  if (NvSituation->Inconnues&&Inconnues)
   for( inconnue *InconnueCrt=NvSituation->Inconnues;
        InconnueCrt;
        InconnueCrt=InconnueCrt->Svt)
    Inconnues->Enrichit(InconnueCrt);
  // Puis les conditions
  if (NvSituation->Conditions)
   { // les conditions sont places dans le mme ordre : pas de boucle on parcourt par rcurrence
    if (!Conditions)
     Conditions=new condition(this, NvSituation->Conditions->Type);
    Conditions->Enrichit(NvSituation->Conditions);
   }
  if (Recherche->Trace)
   AjouteTraceArbre(IDB_VARIABLEETAT, asTraceInconnues(), NOEUD_COURANT);
 }
//---------------------------------------------------------------------------
AnsiString situation::asSolution()
 {
  return Inconnues?
         (asDebutSolution+Inconnues->asSolution()):
         asSolutionVide;
 }
//---------------------------------------------------------------------------
inline bool situation::UnifieContraintesSuivantes( contrainte *Contrainte, // Contrainte source (appel rcursif)
                                                   bool DerniereContrainteParent) // Position de la dernire contrainte russie (v0.3.2)
 {
  int SvgLargeur=Largeur; AnsiString asSvgCode=asCode;
  DefinitLargeurSuivante();
  if (Recherche->Trace) TreeNodeCrt=TreeNodeCrt->Parent;
  bool ContrainteOk=Unifie(Contrainte->Svt, DerniereContrainteParent); // RECURRENCE EN LARGEUR
  Largeur=SvgLargeur; asCode=asSvgCode;
  ArgumentsBut=Contrainte->Arguments;
  if (Recherche->Trace) TreeNodeCrt=TreeNodeCrt->Parent;
  return ContrainteOk;
 }
//---------------------------------------------------------------------------
bool situation::UnifieReglePredefinie(contrainte *Contrainte) // Pr-requis : Contrainte->Regle->TypeReglePredefinie>0
 {
  // 1. On cre la nouvelle condition
  bool ConditionNouvelle;
  condition *ConditionCrt=Conditions?Conditions->Condition(Contrainte->Regle->TypeReglePredefinie):NULL;
  if (ConditionNouvelle=(!ConditionCrt))
   {
    ConditionCrt=new condition(this, Contrainte->Regle->TypeReglePredefinie);
    AjouteCondition(ConditionCrt);
   }
  // 2. On dtermine chaque inconnue de la contrainte de recherche  partir des arguments de la rgle prdfinie (paramtre Contrainte)
  for(argument *ArgumentCrt=Contrainte->Arguments; ArgumentCrt; ArgumentCrt=ArgumentCrt->Svt)
   {
    inconnue *InconnueCrt=Inconnues->Inconnue(ArgumentCrt->asIdentificateur);
    ConditionCrt->AjouteInconnue(InconnueCrt, !ConditionNouvelle); // S'il s'agit d'une nouveau type de condition, alors on ne teste pas l'existante de l'inconnue dans la liste
    if (ConditionNouvelle) InconnueCrt->AjouteCondition(ConditionCrt);
   }
  return ConditionCrt->Possibles();
 }
//---------------------------------------------------------------------------
// Mthode principale de recherche
// Les variables locales SignatureCrt, DefinitionCrt puis ContrainteCrt dterminent
// la situation de l'unification de Contrainte passe en paramtre
//---------------------------------------------------------------------------
bool situation::Unifie( contrainte *Contrainte, // Contrainte  unifier
                        bool DerniereContrainteParent) // Position de la dernire contrainte russie (v0.3.2)
 { // (*) Note : SVT|CRT<S|D,0|1>.LIT|ECRIT indique les oprations sur les indicateurs de recherche. Lgende : S=Signature,D=Dfinition) (0=Profondeur Courante, 1=Profondeur Suivante)
  CompleteInconnuesEtDefinitBut(Contrainte->Arguments);
  regle *Regle=Contrainte->Regle;
  if (!Regle) return false;
  if (Recherche->Trace)
   {
    AnsiString asContraintes=Contrainte->asContrainte();
    AjouteTraceArbre(IDB_CONTRAINTE, asContraintes, NOUVEAU_NOEUD);
   }
  if (Regle->TypeReglePredefinie)
   {
    bool ContrainteOk=UnifieReglePredefinie(Contrainte);
    if (Recherche->Trace)
     Recherche->Arbre->CreeNoeud( TreeNodeCrt->Parent,
                                  Format( asFrmEchecReussite,
                                          ARRAYOFCONST (( asEchecReussite[ContrainteOk],
                                                          asDeLaContrainte,
                                                          Contrainte->asContrainte()))),
                                  ContrainteOk?IDB_STOPREUSSITE:IDB_STOPECHEC,
                                  NULL);
    if (ContrainteOk)
     ContrainteOk=((!Contrainte->Svt)||
                   UnifieContraintesSuivantes( Contrainte,
                                               DerniereContrainteParent)); // RECURRENCE EN LARGEUR
    return ContrainteOk;
   }
  signature *SignatureCrt=Contrainte->SignatureCrtCode(asCode, Regle->Signatures); // CRT<S,0>.LIT*
  if (!SignatureCrt) return false; // *** ECHEC UNIFICATION ***
  bool ContrainteOk;
  do
   {
    for( ContrainteOk=false;
         SignatureCrt&&
         (!UnifiableAvecArgumentsBut(SignatureCrt->Arguments));
         SignatureCrt=SignatureCrt->Svt);
    Contrainte->DefinitSignatureCrt(asCode, SignatureCrt); // CRT<S,0>.ECRIT*
    if (!SignatureCrt)
     {
      if (Recherche->Trace) // v0.3.4
       Recherche->Arbre->CreeNoeud( TreeNodeCrt->Parent,
                                    Format( asFrmEchecReussite,
                                            ARRAYOFCONST (( asEchecReussite[ECHEC],
                                                            asDeLaContrainte,
                                                            Contrainte->asContrainte()))),
                                    IDB_STOPECHEC,
                                    NULL);
      return false; // *** ECHEC UNIFICATION ***
     }
    definition *DefinitionCrt=Contrainte->DefinitionCrtCode(asCode, SignatureCrt->Definitions); // CRT<D,0>.LIT*
    if (!DefinitionCrt)
     { // On change de signature
      SignatureCrt=SignatureCrt->Svt;
      continue;
     }
    Contrainte->DefinitDefinitionCrt(asCode, DefinitionCrt); // CRT<D,0>.ECRIT*
    situation *NvSituation=new situation(this, SignatureCrt->Arguments, Contrainte->Arguments);
    TTreeNode *TreeNodeDefinition;
    contrainte *ContrainteCrt=DefinitionCrt->Contraintes;
    if (Recherche->Trace)
     {
      // On cre le noeud Dfinition
      NvSituation->AjouteTraceArbre( IDB_DEFINITION,
                                     SignatureCrt->Regle->asIdentificateur+
                                     SignatureCrt->asSignature()+
                                     AnsiString(SeparateurSignatureContraintes)+
                                     DefinitionCrt->asContraintes(),
                                     NOUVEAU_NOEUD);
      TreeNodeDefinition=NvSituation->TreeNodeCrt; // On retient le noeud de la dfinition
      // On montre le passage de variables
      NvSituation->AjouteTraceArbre( IDB_VARIABLEETAT,
                                     NvSituation->asTraceInconnues(),
                                     NOEUD_COURANT);
     }
    bool AucuneContrainte;
    if (AucuneContrainte=!ContrainteCrt)
     ContrainteOk=true;
    else
     {
      ContrainteOk=NvSituation->ConditionsPossibles(); // Puisque l'on a transfr les variables on teste les nouvelles conditions
      if (ContrainteOk)
       ContrainteOk=NvSituation->Unifie( ContrainteCrt,
                                         DerniereContrainteParent&&(!Contrainte->Svt)); // RECURRENCE EN PROFONDEUR
     }
    if (Recherche->Trace)
     {
      if (AucuneContrainte)
       Recherche->Arbre->CreeNoeud( TreeNodeDefinition->Parent,
                                    asAucuneContrainte,
                                    IDB_STOPREUSSITE,
                                    NULL);
      else
       {
        AnsiString asContraintes= SignatureCrt->Regle->asIdentificateur+
                                  SignatureCrt->asSignature()+
                                  AnsiString(SeparateurSignatureContraintes)+
                                  DefinitionCrt->asContraintes();
        Recherche->Arbre->CreeNoeud( TreeNodeDefinition->Parent,
                                     Format( asFrmEchecReussite,
                                             ARRAYOFCONST (( asEchecReussite[ContrainteOk],
                                                             asDeLaDefinition,
                                                             asContraintes))),
                                     IDB_STOPECHEC+ContrainteOk,
                                     NULL);
       }
     }
    if (ContrainteOk)
     {
      EnrichitInconnuesEtConditions(NvSituation);
      ContrainteOk=ConditionsPossibles(); // Suite  l'enrichissement des variables, on teste si les conditions sont toujours possibles...
     }

    if (Recherche->Trace&&ContrainteOk) // v0.3.4
     Recherche->Arbre->CreeNoeud( TreeNodeCrt->Parent,
                                  Format( asFrmEchecReussite,
                                          ARRAYOFCONST (( asEchecReussite[ContrainteOk],
                                                          asDeLaContrainte,
                                                          Contrainte->asContrainte()))),
                                  ContrainteOk?IDB_STOPREUSSITE:IDB_STOPECHEC,
                                  NULL);



    delete NvSituation;
    NvSituation=NULL;
    if (ContrainteOk) // Si pas contrainte ou que si contrainte il y a elle est vrifie (unifie),
     { // il faut vrifier (unifier) les autres contraintes de *Contrainte (Recursivit en largueur)
      if (Contrainte->Svt)
       {
        ContrainteOk=UnifieContraintesSuivantes( Contrainte,
                                                 DerniereContrainteParent); // RECURRENCE EN LARGEUR
        if (!ContrainteOk)
         {
          if (Recherche->Trace) // Remet le noeud de la contrainte de dpart
           {
            Recherche->Arbre->CreeNoeud(TreeNodeCrt, "Nouvelle valuation des contraintes", IDB_AVERTISSEMENT, NULL); // v0.3.4
            AjouteTraceArbre(IDB_CONTRAINTE, Contrainte->asContrainte(), NOUVEAU_NOEUD);
           }
          //Reinitialise(Contrainte->Arguments); // On rinitialise la situation de dpart
          if (!AucuneContrainte)
           {
            PasseSignatureDefinitionSvteDrnContrainte(Contrainte, asCode); 
            continue; // v0.3.2. Si Contrainte a des contraintes on ne change pas de Signature/Dfinition : c'est fait que pour la dernire contrainte russie
           }
         }
       }
      else
       {
        if (AucuneContrainte&&DerniereContrainteParent) // *** TERMINAISON *** On remonte le rsultat aprs tre pass au suivant (Signature/Definition)
         {
          DefinitionCrt=Contrainte->DefinitionCrt->SvtCode(asCode); // SVT<D,0>.LIT*
          Contrainte->DefinitDefinitionCrt(asCode, DefinitionCrt); // CRT<D,0>.ECRIT*
          if (!DefinitionCrt) // S'il n'y a plus de dfinitions, il faut voir d'autres signatures
           {
            SignatureCrt=Contrainte->SignatureCrt->SvtCode(asCode); // SVT<S,0>.LIT*
            if (SignatureCrt)
             Contrainte->DefinitDefinitionCrt(asCode, SignatureCrt->Definitions); // Si SignatureCrt est dfinie, on met la premire dfinition de SignatureCrt
            Contrainte->DefinitSignatureCrt(asCode, SignatureCrt); // CRT<S,0>.ECRIT*
           }
         }
       }
     }
    if (!ContrainteOk)
     {
      DefinitionCrt=Contrainte->DefinitionCrt->SvtCode(asCode); // SVT<D,0>.LIT*
      Contrainte->DefinitDefinitionCrt(asCode, DefinitionCrt); // CRT<D,0>.ECRIT*
      if (!DefinitionCrt) // S'il n'y a plus de dfinitions, il faut voir d'autres signatures
       {
        SignatureCrt=Contrainte->SignatureCrt->SvtCode(asCode); // SVT<S,0>.LIT*
        if (SignatureCrt)
         Contrainte->DefinitDefinitionCrt(asCode, SignatureCrt->Definitions); // Si SignatureCrt est dfinie, on met la premire dfinition de SignatureCrt
       }
     }
   }
  while(!ContrainteOk);
  return true; // *** REUSSITE UNIFICATION ***
 }
//---------------------------------------------------------------------------
// Trouve la dernire contrainte en profondeur  partir de Contrainte 
// la position asCode et passe  la signature/dfinition suivante
//---------------------------------------------------------------------------
bool situation::PasseSignatureDefinitionSvteDrnContrainte(contrainte *Contrainte, const AnsiString asCode)
 {
  if (!Contrainte->Regle) return false;
  signature *SignatureCrt=Contrainte->SignatureCrtCode(asCode, Contrainte->Regle->Signatures); // CRT<S,0>.LIT*
  if (!SignatureCrt) return false;
  definition *DefinitionCrt=Contrainte->DefinitionCrtCode(asCode, SignatureCrt->Definitions); // CRT<D,0>.LIT*
  if (!DefinitionCrt) return false;
  contrainte *ContrainteCrt, *DrnContrainte=DefinitionCrt->Contraintes;
  if (!DrnContrainte) // On l'a trouve !
   {
    Contrainte->DefinitSignatureCrt(asCode, SignatureCrt); // CRT<S,0>.ECRIT* (Au cas o c'est la premire signature non encore enregistre)
    Contrainte->DefinitDefinitionCrt(asCode, DefinitionCrt); // CRT<D,0>.ECRIT* (Au cas o c'est la premire dfinition non encore enregistre)
    definition *DefinitionSvt=Contrainte->DefinitionCrt->SvtCode(asCode); // SVT<D,0>.LIT*
    Contrainte->DefinitDefinitionCrt(asCode, DefinitionSvt); // CRT<D,0>.ECRIT*
    if (!DefinitionSvt) // S'il n'y a plus de dfinitions, il faut voir d'autres signatures
     {
      Contrainte->DefinitSignatureCrt(asCode, SignatureCrt); // CRT<S,0>.ECRIT*
      signature *SignatureSvt=Contrainte->SignatureCrt->SvtCode(asCode); // SVT<S,0>.LIT*
      if (SignatureSvt)
       Contrainte->DefinitDefinitionCrt(asCode, SignatureSvt->Definitions); // Si SignatureCrt est dfinie, on met la premire dfinition de SignatureSvt
      Contrainte->DefinitSignatureCrt(asCode, SignatureSvt); // CRT<S,0>.ECRIT*
     }
    return true;
   }
  int i;
  for( i=0, ContrainteCrt=DrnContrainte;
       ContrainteCrt;
       i+=(!ContrainteCrt->Regle->TypeReglePredefinie), ContrainteCrt=ContrainteCrt->Svt)
   {
    if (!ContrainteCrt->Regle) return false;
    if (!ContrainteCrt->Regle->TypeReglePredefinie)
     DrnContrainte=ContrainteCrt;
   }
  return PasseSignatureDefinitionSvteDrnContrainte(DrnContrainte, asCode+IntToStr(i));
 }
//---------------------------------------------------------------------------
void recherche::AjouteSolution(situation *Situation)
 {
  NbSolutions++;
  slSortie->Add(Situation->asSolution());
  TreeNodeSolutions->Text=asNbSolutions();
  Arbre->CreeNoeud( TreeNodeSolutions,
                    Situation->asSolution(),
                    IDB_SOLUTION,
                    NULL);
  if (Trace)
   Situation->AjouteTraceArbre( IDB_SOLUTION,
                                Situation->asSolution(),
                                NOEUD_COURANT);
 };
//---------------------------------------------------------------------------
void situation::AjouteTraceArbre(int IndexImage, const AnsiString asLibelle, bool NouveauNoeud)
 {
  int i;
  TTreeNode *TreeNodeCrt=this->TreeNodeCrt?this->TreeNodeCrt:Recherche->TreeNodeTrace,
            *NvTreeNode=NULL;
  NvTreeNode=Recherche->Arbre->CreeNoeud( TreeNodeCrt,
                                          asLibelle,
                                          IndexImage,
                                          NULL);
  if (NouveauNoeud) // Le nouveau noeud devient le noeud courant de la trace.
   this->TreeNodeCrt=NvTreeNode;
 };
//---------------------------------------------------------------------------
bool recherche::Cherche(TStrings *slSortie, bool Trace, bool StopApresPremiereSolution)
 {
  bool SolutionTrouvee;
  this->slSortie=slSortie;
  this->Trace=Trace;
  do
   {
    situation PrmSituation(NULL, Question->Contraintes->Arguments, NULL);
    if (SolutionTrouvee=PrmSituation.Unifie(Question->Contraintes, DERNIERE_CONTRAINTE_PARENT))
     {
      if (!NbSolutions) slSortie->Add("Oui :");
      AjouteSolution(&PrmSituation);
     }
   }
  while((!StopApresPremiereSolution)&&SolutionTrouvee);
  if (!NbSolutions)
   {
    slSortie->Add("Non.");
    return false;
   }
  else
   if (StopApresPremiereSolution)
    if (SolutionTrouvee)
     return true;
    else
     {
      slSortie->Add(Format("Il n'y a plus de solutions : %d solution(s) trouve(s).", ARRAYOFCONST((NbSolutions))));
      return false;
     }
   else
    {
     slSortie->Add(Format("%d solution(s) trouve(s).", ARRAYOFCONST((NbSolutions))));
     return true;
    }
 }
//---------------------------------------------------------------------------

